import 'dart:io';
import 'package:flutter/services.dart';

class WebRTC {
  static const MethodChannel _channel = MethodChannel('FlutterWebRTC.Method');
  static MethodChannel methodChannel() => _channel;

  static bool get platformIsDesktop =>
      Platform.isWindows ||
      Platform.isLinux ||
      Platform.isMacOS ||
      Platform.isLinux;

  static bool get platformIsWindows => Platform.isWindows;

  static bool get platformIsLinux => Platform.isLinux;

  static bool get platformIsMobile => Platform.isIOS || Platform.isAndroid;

  static bool get platformIsIOS => Platform.isIOS;

  static bool get platformIsAndroid => Platform.isAndroid;

  static bool get platformIsWeb => false;

  static Future<T> invokeMethod<T, P>(String methodName,
      [dynamic param]) async {
    var response = await _channel.invokeMethod<T>(
      methodName,
      param,
    );

    if (response == null) {
      throw Exception('Invoke method: $methodName return a null response');
    }

    return response;
  }
}
